(* 
Authors: Brody Berg, Max Czapanskiy
Date: Fall 2008
*)

type op = Assign | Mod | Add | Sub | Mult | Div | Equal | Neq | Less | Leq | Greater | Geq

type statement = 
   Empty
 | Int of int
 | String of string
 | Id of string
 | LibCallP of statement
 | LibCallIS of statement
 | Binop of statement * op * statement

type call = {
   state: string;
   args: statement list;
}

type transition = {
   condition: statement;
   actions: statement list;
   target: call;
}

type state = {
   sname: string;
   formals: statement list;
   statements: statement list;
   transitions: transition list;
}

type program = state list
