{
(*
Authors: Brody Berg, Max Czapanskiy
Date: Fall 2008
*)

  open Grammar (* Assumes the parser file is "grammar.mly". *)
}

rule token = parse
  | [' ' '\t' '\n' '\r']  { token lexbuf }
  | '#'         { comment lexbuf }
  | "End"       { END }
  | "print"     { PRINT }
  | "int_to_str" { INTTOSTRING }
  | '('         { LPAREN }
  | ')'         { RPAREN }
  | '<'         { LT }
  | '>'         { GT }
  | "=="        { EQ }
  | '='         { ASSIGN } 
  | '+'         { PLUS }
  | '-'         { MINUS }
  | '*'         { TIMES }
  | '/'         { DIVIDE }
  | '%'         { MOD }
  | '?'         { QUESTION }  
  | ['0' - '9']+                         as lxm { INT(int_of_string lxm) }
  | '"'(['a'-'z' 'A'-'Z' '0'-'9' ' ' '\t' '\n' '\r']*)'"' as lxm { STRING(lxm) } 
  | ['a'-'z' 'A'-'Z']['0'-'9' 'a'-'z' 'A'-'Z']*        as lxm { ID(lxm) }  
  | ','         { COMMA }
  | ':'         { COLON }
  | ';'         { SEMI }
  | "->"        { ARROW }
  | eof { EOF }
  | _ as char { raise (Failure("illegal character " ^ Char.escaped char)) }

and comment = parse
'\n'   { token lexbuf }
| _    { comment lexbuf }

